'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.setParams = setParams;
exports.filterParams = filterParams;

var _fp = require('lodash/fp');

var _fp2 = _interopRequireDefault(_fp);

var _url = require('url');

var _url2 = _interopRequireDefault(_url);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function parseUrl(url) {
  return _fp2.default.omit(['search', 'hash'], _url2.default.parse(url, true));
}

function setParams(url, params) {
  var parsedUrl = parseUrl(url);
  return _url2.default.format(_fp2.default.set('query', _fp2.default.assign(parsedUrl.query, params), parsedUrl));
}

function filterParams(url, whitelist) {
  var parsedUrl = parseUrl(url);
  return _url2.default.format(_fp2.default.set('query', _fp2.default.pick(whitelist, parsedUrl.query), parsedUrl));
}