'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var ensurePromises = function () {
  var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(browser) {
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (!process.env.HEADLESS) {
              _context.next = 3;
              break;
            }

            _context.next = 3;
            return browser.executeScript(getSourceForModule('es6-promise'));

          case 3:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function ensurePromises(_x) {
    return _ref.apply(this, arguments);
  };
}();

var injectJQuery = function () {
  var _ref2 = _asyncToGenerator(regeneratorRuntime.mark(function _callee2(browser) {
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return browser.executeScript('\n      var _old$ = window.$;\n      var _oldjQuery = window.jQuery;\n      ' + getSourceForModule('jquery') + ';\n      window.__SCRAPERJS_JQUERY = window.jQuery;\n      window.$ = _old$;\n      window.jQuery = _oldjQuery;\n    ');

          case 2:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function injectJQuery(_x2) {
    return _ref2.apply(this, arguments);
  };
}();

var injectAtoms = function () {
  var _ref3 = _asyncToGenerator(regeneratorRuntime.mark(function _callee3(browser) {
    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return browser.executeScript(atomsSrc + '; window.bot = bot;');

          case 2:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));

  return function injectAtoms(_x3) {
    return _ref3.apply(this, arguments);
  };
}();

var fixClickHandlers = function () {
  var _ref4 = _asyncToGenerator(regeneratorRuntime.mark(function _callee4(browser) {
    return regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _context4.next = 2;
            return browser.executeScript(function () {
              window.__SCRAPERJS_JQUERY.fn.extend({
                // eslint-disable-line no-underscore-dangle
                click: function click() {
                  bot.action.click(this.get(0));
                }
              });
            });

          case 2:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee4, this);
  }));

  return function fixClickHandlers(_x4) {
    return _ref4.apply(this, arguments);
  };
}();

var runWithUtils = function () {
  var _ref5 = _asyncToGenerator(regeneratorRuntime.mark(function _callee5(browser, origFn, injectable) {
    var fn, runTheFunction;
    return regeneratorRuntime.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            fn = (0, _wrapFunctionWithBabelHelpers2.default)(origFn);

            runTheFunction = function runTheFunction(userFnStr, utilsStr, callback) {
              var utils = eval(utilsStr); // eslint-disable-line no-eval

              try {
                var fnFromString = function fnFromString(fnStr) {
                  var _fnStr$match = fnStr.match(/^function[^(]*\(([^)]*)\) {((?:.|\s)*)}$/);

                  var _fnStr$match2 = _slicedToArray(_fnStr$match, 3);

                  var args = _fnStr$match2[1];
                  var body = _fnStr$match2[2];

                  return new Function(args.split(','), body); // eslint-disable-line no-new-func
                };

                var result = void 0;

                try {
                  result = fnFromString(userFnStr)(utils); // eslint-disable-line no-undef
                } catch (error) {
                  return callback({
                    error: error, from: 'user function', message: error.message
                  });
                }

                if (result && result.then && typeof result.then === 'function') {
                  var curryCallback = function curryCallback() {
                    return callback({
                      queue: utils.queue.getQueue(),
                      data: utils.data.getData(),
                      finalUrl: window.location.href
                    });
                  };
                  result.then(curryCallback, function (error) {
                    return callback({
                      error: error,
                      message: error.message,
                      from: 'user function promise',
                      err: JSON.stringify(error),
                      stack: error.stack
                    });
                  });
                  return undefined;
                }

                callback({
                  queue: utils.queue.getQueue(),
                  data: utils.data.getData(),
                  finalUrl: window.location.href
                });
              } catch (error) {
                callback({ error: error, message: error.message, from: 'runTheFunction code' });
              }
              return undefined;
            };

            _context5.next = 4;
            return browser.executeAsyncScript((0, _wrapFunctionWithBabelHelpers2.default)(runTheFunction), fn.toString(), injectable.build());

          case 4:
            return _context5.abrupt('return', _context5.sent[0]);

          case 5:
          case 'end':
            return _context5.stop();
        }
      }
    }, _callee5, this);
  }));

  return function runWithUtils(_x5, _x6, _x7) {
    return _ref5.apply(this, arguments);
  };
}();

var addToolsToBrowser = function () {
  var _ref6 = _asyncToGenerator(regeneratorRuntime.mark(function _callee6(browser, log) {
    return regeneratorRuntime.wrap(function _callee6$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            log('ensure promise support');
            _context6.next = 3;
            return ensurePromises(browser);

          case 3:
            log('inject jquery');
            _context6.next = 6;
            return injectJQuery(browser);

          case 6:
            log('inject atoms');
            _context6.next = 9;
            return injectAtoms(browser);

          case 9:
            log('fix jquery click function');
            _context6.next = 12;
            return fixClickHandlers(browser);

          case 12:
          case 'end':
            return _context6.stop();
        }
      }
    }, _callee6, this);
  }));

  return function addToolsToBrowser(_x8, _x9) {
    return _ref6.apply(this, arguments);
  };
}();

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _wrapFunctionWithBabelHelpers = require('./lib/wrapFunctionWithBabelHelpers.js');

var _wrapFunctionWithBabelHelpers2 = _interopRequireDefault(_wrapFunctionWithBabelHelpers);

var _Injectable = require('./lib/Injectable.js');

var _Injectable2 = _interopRequireDefault(_Injectable);

var _queueUtil = require('./lib/queue-util.js');

var _queueUtil2 = _interopRequireDefault(_queueUtil);

var _dataUtil = require('./lib/data-util.js');

var _dataUtil2 = _interopRequireDefault(_dataUtil);

var _within = require('./lib/within.js');

var _within2 = _interopRequireDefault(_within);

var _during = require('./lib/during.js');

var _during2 = _interopRequireDefault(_during);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; } /* globals bot */
/* eslint-disable no-underscore-dangle */

var atomsSrc = _fs2.default.readFileSync(_path2.default.join(__dirname, './lib/atoms.js'), 'utf8');

var getSourceForModule = _lodash2.default.memoize(function (moduleName) {
  return _fs2.default.readFileSync(require.resolve(moduleName), 'utf8');
});

function constructUtils() {
  var injectable = new _Injectable2.default();

  injectable.register({ queue: _queueUtil2.default });
  injectable.register({ data: _dataUtil2.default });
  injectable.register({ within: _within2.default });
  injectable.register({ during: _during2.default });

  injectable.register({
    $: function $() {
      return window.__SCRAPERJS_JQUERY;
    }
  });
  return injectable;
}

exports.default = function () {
  var _ref7 = _asyncToGenerator(regeneratorRuntime.mark(function _callee7(_ref8) {
    var browser = _ref8.browser;
    var queueItem = _ref8.queueItem;
    var scraper = _ref8.scraper;
    var data;
    return regeneratorRuntime.wrap(function _callee7$(_context7) {
      while (1) {
        switch (_context7.prev = _context7.next) {
          case 0:
            data = [];


            scraper.log('navigate to ' + queueItem.url);
            _context7.next = 4;
            return browser.navigate(queueItem.url);

          case 4:
            _context7.prev = 4;
            _context7.next = 7;
            return addToolsToBrowser(browser, scraper.log);

          case 7:
            _context7.next = 9;
            return runWithUtils(browser, scraper[queueItem.method], constructUtils());

          case 9:
            data = _context7.sent;
            return _context7.abrupt('return', data);

          case 13:
            _context7.prev = 13;
            _context7.t0 = _context7['catch'](4);

            if (!(_context7.t0.toString().match(/Document was unloaded during execution/) || _context7.t0.toString().match(/document unloaded while waiting for result/))) {
              _context7.next = 32;
              break;
            }

            scraper.log('retry');
            // page was probably redirected... lets try again?
            _context7.prev = 17;
            _context7.next = 20;
            return addToolsToBrowser(browser, scraper.log);

          case 20:
            _context7.next = 22;
            return browser.executeAsyncScript(function (callback) {
              if (document.readyState === 'complete') {
                callback();
              } else {
                window.__SCRAPERJS_JQUERY(window).on('load', function () {
                  callback();
                });
              }
            });

          case 22:
            _context7.next = 24;
            return runWithUtils(browser, scraper[queueItem.method], constructUtils());

          case 24:
            data = _context7.sent;
            return _context7.abrupt('return', data);

          case 28:
            _context7.prev = 28;
            _context7.t1 = _context7['catch'](17);

            scraper.error('BIGERR: An error occurred processing an item', _context7.t1, 'from url: ', queueItem.url);
            throw _context7.t1;

          case 32:
            scraper.error('BIGERR: An error occurred processing an item', _context7.t0, 'from url: ', queueItem.url);
            throw _context7.t0;

          case 34:
          case 'end':
            return _context7.stop();
        }
      }
    }, _callee7, this, [[4, 13], [17, 28]]);
  }));

  function processBrowser(_x10) {
    return _ref7.apply(this, arguments);
  }

  return processBrowser;
}();