'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _requestPromise = require('request-promise');

var _requestPromise2 = _interopRequireDefault(_requestPromise);

var _cloneDeep = require('lodash/cloneDeep');

var _cloneDeep2 = _interopRequireDefault(_cloneDeep);

var _queueUtil = require('./lib/queue-util.js');

var _queueUtil2 = _interopRequireDefault(_queueUtil);

var _dataUtil = require('./lib/data-util.js');

var _dataUtil2 = _interopRequireDefault(_dataUtil);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

exports.default = function () {
  var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(_ref2) {
    var cheerio = _ref2.cheerio;
    var queueItem = _ref2.queueItem;
    var scraper = _ref2.scraper;
    var switchUse = _ref2.switchUse;
    var content, $, baseHref, utils, data;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            _context.next = 3;
            return (0, _requestPromise2.default)({
              uri: queueItem.url,
              resolveWithFullResponse: true,
              headers: {
                'User-Agent': queueItem.userAgent || 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/54.0.2840.59 Safari/537.36'
              }
            });

          case 3:
            content = _context.sent;
            $ = cheerio.load(content.body, content.request.href);
            baseHref = $('base').attr('href') || content.request.href;

            // we shouldn't change this private property, but considering there's no good way of changing
            // the baseHref without reloading the content in cheerio, we'll allow it for now.

            $._options.baseHref = baseHref; // eslint-disable-line no-underscore-dangle

            utils = {
              $: $,
              queueItem: (0, _cloneDeep2.default)(queueItem),
              queue: (0, _queueUtil2.default)(),
              data: (0, _dataUtil2.default)(),
              use: function use(method) {
                return switchUse(method);
              }
            };
            _context.next = 10;
            return scraper[queueItem.method](utils);

          case 10:
            data = _context.sent;

            if (!(data && data.finalUrl)) {
              _context.next = 14;
              break;
            }

            // looks like they used switch
            console.log('Looks like they switched methods');
            return _context.abrupt('return', data);

          case 14:
            return _context.abrupt('return', {
              queue: utils.queue.getQueue(),
              data: utils.data.getData(),
              finalUrl: content.request.href
            });

          case 17:
            _context.prev = 17;
            _context.t0 = _context['catch'](0);

            scraper.error('BIGERR: An error occurred processing an item', _context.t0, 'from url: ', queueItem.url);

          case 20:
            return _context.abrupt('return', []);

          case 21:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this, [[0, 17]]);
  }));

  function processCheerio(_x) {
    return _ref.apply(this, arguments);
  }

  return processCheerio;
}();