#!/usr/bin/env node
'use strict';

var start = function () {
  var _ref5 = _asyncToGenerator(regeneratorRuntime.mark(function _callee4() {
    var _this2 = this;

    var _marked, scrapers, nextScraper;

    return regeneratorRuntime.wrap(function _callee4$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            nextScraper = function nextScraper() {
              var i;
              return regeneratorRuntime.wrap(function nextScraper$(_context3) {
                while (1) {
                  switch (_context3.prev = _context3.next) {
                    case 0:
                      i = 0;

                    case 1:
                      if (!true) {
                        _context3.next = 9;
                        break;
                      }

                      // eslint-disable-line no-constant-condition
                      if (i >= scrapers.length) {
                        i = 0;
                      }
                      log('nextScraper', i);
                      _context3.next = 6;
                      return scrapers[i];

                    case 6:
                      i += 1;
                      _context3.next = 1;
                      break;

                    case 9:
                    case 'end':
                      return _context3.stop();
                  }
                }
              }, _marked[0], this);
            };

            _marked = [nextScraper].map(regeneratorRuntime.mark);
            _context5.next = 4;
            return (0, _getScrapers2.default)(_commander2.default.args);

          case 4:
            scrapers = _context5.sent;


            setInterval(function () {
              log.warn('Checking items', itemsCompleted);
              if (itemsCompleted === 0) {
                log.warn('Exiting due to 0 items being completed');
                process.exit();
              }
              itemsCompleted = 0;
            }, 60000);

            _context5.next = 8;
            return (0, _promiseEachConcurrency2.default)(nextScraper(), function () {
              var _ref6 = _asyncToGenerator(regeneratorRuntime.mark(function _callee3(scraper) {
                var result;
                return regeneratorRuntime.wrap(function _callee3$(_context4) {
                  while (1) {
                    switch (_context4.prev = _context4.next) {
                      case 0:
                        scraper.log('start processing queue');
                        _context4.prev = 1;
                        _context4.next = 4;
                        return startQueue(scraper);

                      case 4:
                        result = _context4.sent;

                        scraper.log('finished processing queue');
                        return _context4.abrupt('return', result);

                      case 9:
                        _context4.prev = 9;
                        _context4.t0 = _context4['catch'](1);

                        scraper.error('BIGERR: A caught error below');
                        scraper.error(_context4.t0);
                        scraper.error(_context4.t0.stack);

                      case 14:
                      case 'end':
                        return _context4.stop();
                    }
                  }
                }, _callee3, _this2, [[1, 9]]);
              }));

              return function (_x3) {
                return _ref6.apply(this, arguments);
              };
            }(), { concurrency: _commander2.default.concurrency });

          case 8:
          case 'end':
            return _context5.stop();
        }
      }
    }, _callee4, this);
  }));

  return function start() {
    return _ref5.apply(this, arguments);
  };
}();

var _fp = require('lodash/fp');

var _fp2 = _interopRequireDefault(_fp);

var _debug = require('debug');

var _debug2 = _interopRequireDefault(_debug);

var _commander = require('commander');

var _commander2 = _interopRequireDefault(_commander);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _promiseEachConcurrency = require('promise-each-concurrency');

var _promiseEachConcurrency2 = _interopRequireDefault(_promiseEachConcurrency);

var _cheerio = require('cheerio');

var _cheerio2 = _interopRequireDefault(_cheerio);

var _browser = require('./lib/browser.js');

var _browser2 = _interopRequireDefault(_browser);

var _getScrapers = require('./getScrapers.js');

var _getScrapers2 = _interopRequireDefault(_getScrapers);

var _process = require('./process.js');

var _process2 = _interopRequireDefault(_process);

var _requireES = require('./lib/requireES6.js');

var _requireES2 = _interopRequireDefault(_requireES);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var log = (0, _debug2.default)('scraperjs:log');
log.error = (0, _debug2.default)('scraperjs:error');
log.warn = (0, _debug2.default)('scraperjs:warn');

function parseConcurrency(istr) {
  return +istr;
}

_commander2.default.version(require('../package.json').version).option('-q, --queue <file>', 'Use this queue plugin [memory]').option('-d, --data <file>', 'Use this data plugin').option('-c, --concurrency <number>', 'How many browser instances to use', parseConcurrency, 1).parse(process.argv);

if (!_commander2.default.queue || !_commander2.default.data) {
  _commander2.default.help();
}

var dataPlugin = (0, _requireES2.default)(_path2.default.resolve(_commander2.default.data));
var queuePlugin = (0, _requireES2.default)(_path2.default.resolve(_commander2.default.queue));

var itemsCompleted = 0;

function startQueue(scraper) {
  return new Promise(function () {
    var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee2(resolve) {
      var _this = this;

      var browser, scraperQueue, addToQueue, filterQueueItems, queueCount;
      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              browser = void 0;
              scraperQueue = queuePlugin('scraperjs:' + scraper.name);

              // @todo maybe the scraper queue should be instantiated with expiry

              addToQueue = function addToQueue(queueItem) {
                return scraperQueue.add(_fp2.default.assign({ expiry: scraper.timeBetween }, queueItem));
              };

              filterQueueItems = function filterQueueItems(queueItem) {
                if (scraper.filterQueueItem) {
                  // eslint-disable-next-line no-param-reassign
                  queueItem.url = scraper.filterQueueItem(queueItem);
                }
                return queueItem;
              };

              scraper.log('Add start item to the queue');

              _context2.next = 7;
              return addToQueue(scraper.start);

            case 7:

              scraper.log('Check queue count');
              _context2.next = 10;
              return scraperQueue.count();

            case 10:
              queueCount = _context2.sent;

              if (!(queueCount === 0)) {
                _context2.next = 15;
                break;
              }

              scraper.log('Finishing up as there is nothing in the queue');
              setTimeout(function () {
                scraperQueue.close();
                resolve();
              }, 10000);
              return _context2.abrupt('return');

            case 15:

              // if ((scraper.use || 'browser') === 'browser') {
              scraper.log('starting browser');
              _context2.next = 18;
              return (0, _browser2.default)();

            case 18:
              browser = _context2.sent;

              scraper.log('browser started');
              // }

              scraperQueue.process(function () {
                var _ref2 = _asyncToGenerator(regeneratorRuntime.mark(function _callee(queueItem) {
                  var _ref3, queue, data, finalUrl, promises, count;

                  return regeneratorRuntime.wrap(function _callee$(_context) {
                    while (1) {
                      switch (_context.prev = _context.next) {
                        case 0:
                          itemsCompleted += 1;

                          scraper.log('process', queueItem.url);

                          if (!(queueItem.use === 'browser' && !browser)) {
                            _context.next = 8;
                            break;
                          }

                          scraper.log('starting browser');
                          _context.next = 6;
                          return (0, _browser2.default)();

                        case 6:
                          browser = _context.sent;

                          scraper.log('browser started');

                        case 8:
                          _context.next = 10;
                          return (0, _process2.default)({
                            browser: browser,
                            queueItem: queueItem,
                            scraper: scraper,
                            cheerio: _cheerio2.default
                          }).catch(function (err) {
                            console.error('error processing item', err);
                            throw err;
                          });

                        case 10:
                          _ref3 = _context.sent;
                          queue = _ref3.queue;
                          data = _ref3.data;
                          finalUrl = _ref3.finalUrl;

                          scraper.log('finished!', queueItem.url);

                          promises = [];


                          if (queue && queue.length) {
                            promises = _fp2.default.uniqBy('url')(queue.map(filterQueueItems)).filter(function (_ref4) {
                              var url = _ref4.url;

                              if (!url.match(/:\/\//)) {
                                log.error('ignoring invalid url queue attempt', url);
                                return false;
                              }
                              return true;
                            }).map(function (_queueItem) {
                              return addToQueue(_queueItem);
                            });
                          }

                          if (data) {
                            promises.push(dataPlugin({
                              url: queueItem.url,
                              finalUrl: finalUrl,
                              method: queueItem.method,
                              scraper: scraper.name,
                              timestamp: +new Date(),
                              data: data
                            }));
                          }

                          _context.next = 20;
                          return Promise.all(promises);

                        case 20:
                          _context.next = 22;
                          return scraperQueue.count();

                        case 22:
                          count = _context.sent;


                          if (count === 0) {
                            scraperQueue.close();
                            browser.quit();
                            resolve();
                          }

                        case 24:
                        case 'end':
                          return _context.stop();
                      }
                    }
                  }, _callee, _this);
                }));

                return function (_x2) {
                  return _ref2.apply(this, arguments);
                };
              }());

            case 21:
            case 'end':
              return _context2.stop();
          }
        }
      }, _callee2, this);
    }));

    function processQueue(_x) {
      return _ref.apply(this, arguments);
    }

    return processQueue;
  }());
}

start().catch(function (error) {
  log.error('BIGERR: A caught error', error);
  log.error(error.stack);
});